function [Re] = ResponseFunction(imageplane) %corner point-detection function
I = double(imageplane);                      % convert image to double format
hx = [-1 0 1];                          % horizontal convolution window for first derivative
hy = [-1 ; 0 ; 1];                      % vertical convolution window for first derivative
for i=1:3                               % window for corner detection response
   for j=1:3
      w(i,j) = exp(-(i*i + j*j)/(2* 0.3 * 0.3));
   end;
end;

%w = 1/9 * [1 1 1; 1 1 1; 1 1 1];
A1 = imfilter(I,hx,'conv');             % First Derivative of x
A2 = immultiply(A1,A1);                
A  = imfilter(A2,w,'conv');            
B1 = imfilter(I,hy,'conv');             % First Derivative of y
B2 = immultiply(B1,B1);
B  = imfilter(B2,w,'conv');
C2 = immultiply(A1,B1);
C  = imfilter(C2,w,'conv');
%figure, imshow(A)
%figure, imshow(B)
%figure, imshow(C)
[sizey,sizex] = size(I);               % size of Image
Re = zeros(sizey,sizex);
k = 0.04;
for i = 1: sizey
    for j = 1:sizex
        M = zeros(2,2);                % Response Matrix  'M'
        M(1,1) = A(i,j);
        M(1,2) = C(i,j);
        M(2,1) = C(i,j);
        M(2,2) = B(i,j);
        
        TraceOfM = M(1,1) + M(2,2);
        TraceSquare = TraceOfM * TraceOfM;
        DetOfM = M(1,1)*M(2,2) - M(1,2)*M(2,1);
        Re(i,j) = DetOfM - k * TraceSquare;        % Actual Response 'R'
    end;
end;
%figure, plot(-Re)
        
return;



