%function [img] = cornerDetect(image1)
%corner point-detection function
%image1 = imread('../pictures/mosaic_images/lab1.jpg');
image1 = imread('../pictures/square.jpg');
 
 I = im2double(image1);                      % convert image to double format
 I = rgb2gray(I);
% I1 = I;
% disp(max(max(I)))
figure;
imshow(I);

hx = [-1 0 1];                          % horizontal convolution window for first derivative
hy = [-1 ; 0 ; 1];                      % vertical convolution window for first derivative

A1 = imfilter(I,hx,'conv');             % First Derivative of x
%figure;
%imshow(A1);
A2 = immultiply(A1,A1);
disp('mean of A2')
disp(mean(mean(A2)));
%figure;
%imshow(A2);

B1 = imfilter(I,hy,'conv');             % First Derivative of y
%figure;
%imshow(B1);
B2 = immultiply(B1,B1);
disp('mean of B2')
disp(mean(mean(B2)));
%figure;
%imshow(B2);

C2 = immultiply(A1,B1);
disp('mean of C2')
disp(mean(mean(C2)));
%figure;
%imshow(C2);

[sizey,sizex,sizez] = size(I);               % size of Image

corner = zeros(sizey,sizex,sizez);
A = zeros(sizey+20,sizex+20);
B = zeros(sizey+20,sizex+20);
C = zeros(sizey+20,sizex+20);

for i = 1:sizey
    for j = 1:sizex
        A(i+10,j+10) = A2(i,j);
        B(i+10,j+10) = B2(i,j);
        C(i+10,j+10) = C2(i,j);
    end;
end;

Thresh = 15;
list = 0;
sumA = 0;
sumB = 0;
sumC = 0;
n=1;
check = zeros(sizey,sizex);

for i = 1:sizey
    p = i+10;
    for j = 1:sizex
        q = j+10;
        C1 = zeros(2, 2);                % Response Matrix  'C1'
        for k = -10:10
            for l = -10:10
                sumA = sumA + A(p+k,q+l);
                sumB = sumB + B(p+k,q+l);
                sumC = sumC + C(p+k,q+l);
               % disp(k)
               % disp(l)
            end;
        end;
        
        C1(1,1) = sumA;
        C1(1,2) = sumC;
        C1(2,1) = sumC;
        C1(2,2) = sumB;
        
        sumA = 0;
        sumB = 0;
        sumC = 0;
        
        Eigen = eig(C1);
%        disp(Eigen)
        if Eigen(1,1) < Eigen(2,1)
            lambda2 = Eigen(1,1);
        else
            lambda2 = Eigen(2,1);
        end;
        
        check(i,j) = lambda2;
        if lambda2 > Thresh
           list(1,n) = lambda2;
           list(2,n) = i;
           list(3,n) = j;
           n = n+1;
       end;
    end;
end;
disp('n is')
disp(n)
size(list)
figure;
hist(check);
disp('mean is')
disp(mean(mean(check)))
disp('min is')
disp(min(min(check)))

 for i= 2:(n-1)                      %% Insertion Sort
    index = list(1,i);
    a = list(2,i);
    b = list(3,i);
    j = i;
      while j > 1 & list(1,j-1) < index
          list(1,j) = list(1,j-1);
          list(2,j) = list(2,j-1);
          list(3,j) = list(3,j-1);
          j = j - 1;
      end;
    list(1,j) = index;
    list(2,j) = a;
    list(3,j) = b;
end;
  
% list1 = list(:,1:20);
% disp(list1)

for i = 1:(n-1)
    for j = (i+1):(n-1)
        if (abs(list(2,j)-list(2,i)) < 10) & (abs(list(3,j)-list(3,i)) < 10)
            list(1,j) = 0;
            list(2,j) = 0;
            list(3,j) = 0; 
        end;
    end;
end;
%disp(list)
 m = 1;
 flist = 0;
 for i = 1:(n-1)
     if list(1,i) ~= 0
         flist(1,m) = list(1,i);
         flist(2,m) = list(2,i);
         flist(3,m) = list(3,i);
         m = m+1;
         disp(m)
     end;
 end;
% disp(flist)
 size(flist)
 img = ones(sizey,sizex);

 for i = 2:sizey-1
     for j = 2:sizex-1
         for g = 1:(m-1)
             if flist(2,g) == i & flist(3,g) == j
                 img(i,j) = 0;
%                  img(i,j,2) = 1;
%                  img(i,j,3) = 1;
%                  img(i-1,j-1,1) = 1;
%                  img(i-1,j-1,2) = 0;
%                  img(i-1,j-1,3) = 0;
%                  img(i+1,j+1,1) = 1;
%                  img(i+1,j+1,2) = 0;
%                  img(i+1,j+1,3) = 0;
%                  img(i-1,j+1,1) = 1;
%                  img(i-1,j+1,2) = 0;
%                  img(i-1,j+1,3) = 0;
%                  img(i+1,j-1,1) = 1;
%                  img(i+1,j-1,2) = 0;
%                  img(i+1,j-1,3) = 0;
             end;
         end;
     end;
 end;
 

%   for i = 1:(sizey*sizex)
% %      for j = 1:sizex
% %          for g = 1:(m-1)
%               if list(1,i) > 14
%                   img(list(2,i),list(3,i)) = 1;
%               end;
%    end;
% %      end;
% %  end;
% %  

 %I1 = I + img;
 imwrite(img,'out.jpg');
 im = imread('out.jpg');
 figure;
 imshow(im);
 
return;



