%%%%%%%% Assumptions %%%%%%%%%%%
% 1> Images are gray scale images
% 2> Images are of same size
% 3> Currently designed for 2 images with significant overlap
% 4> Finding corresponding poins in both images is done manually


image1 = imread('./pictures/mosaic_images/labgray1.jpg');  
image2 = imread('./pictures/mosaic_images/labgray2.jpg');      

 %figure;
 %imshow(image1);

 %figure;
 %imshow(image2);

image1 = im2double(image1);
image2 = im2double(image2);

Point1(1,1) = 257;  %% x1             %%%%%%%%%% STEP 1 -- Computing 4 corresponding points in both the images
Point1(2,1) = 120;  %% y1

Point1(1,2) = 394;  %% x2
Point1(2,2) = 242;  %% y2

Point1(1,3) = 560;  %% x3
Point1(2,3) = 137;  %% y3

Point1(1,4) = 608;  %% x4   
Point1(2,4) = 404;  %% y4


Point2(1,1) = 109;  %% x1'
Point2(2,1) = 131;  %% y1'

Point2(1,2) = 240;  %% x2'
Point2(2,2) = 251;  %% y2'

Point2(1,3) = 414;  %% x3'
Point2(2,3) = 145;  %% y3'

Point2(1,4) = 453;  %% x4'
Point2(2,4) = 401;  %% y4'

x1 = Point1(1,1);            %%%%%%%%%%%%%% STEP 2 -- Estimating the homography
y1 = Point1(2,1); 
x2 = Point1(1,2); 
y2 = Point1(2,2); 
x3 = Point1(1,3); 
y3 = Point1(2,3); 
x4 = Point1(1,4);  
y4 = Point1(2,4);
xx1 = Point2(1,1);   
yy1 = Point2(2,1); 
xx2 = Point2(1,2); 
yy2 = Point2(2,2);
xx3 = Point2(1,3);
yy3 = Point2(2,3);
xx4 = Point2(1,4);
yy4 = Point2(2,4);

A = zeros(8,8);
B = zeros(8,1);
X = zeros(8,1);
H = zeros(3,3);

A = [x1 y1 1 0 0 0 -(x1*xx1) -(y1*xx1) ; 0 0 0 x1 y1 1 -(x1*yy1) -(y1*yy1); x2 y2 1 0 0 0 -(x2*xx2) -(y2*xx2) ; 0 0 0 x2 y2 1 -(x2*yy2) -(y2*yy2); x3 y3 1 0 0 0 -(x3*xx3) -(y3*xx3) ; 0 0 0 x3 y3 1 -(x3*yy3) -(y3*yy3); x4 y4 1 0 0 0 -(x4*xx4) -(y4*xx4) ; 0 0 0 x4 y4 1 -(x4*yy4) -(y4*yy4)];
B = [xx1; yy1; xx2; yy2; xx3; yy3; xx4; yy4];

disp(A)
disp(B)
X = A\B;


H = [X(1,1) X(2,1) X(3,1); X(4,1) X(5,1) X(6,1); X(7,1) X(8,1) 1];
disp(H)
Hinv = zeros(3,3);                    %%%%%%%%%%%%%% STEP 3 -- Applying H-inverse to the right image
Hinv = inv(H);
disp(Hinv)

[sizey,sizex] = size(image2);

n=1;
PP=zeros(3,sizey*sizex);
disp('Now in STEP 3')
for i= 1:sizey
    for j = 1:sizex
        PP(1,n) = j;
        PP(2,n) = i;
        PP(3,n) = 1;
        n = n+1;
    end;
end;



n=1;
intensity = zeros(1,sizey*sizex);
for i = 1:sizey
    for j = 1:sizex
        intensity(1,n) = image2(i,j);
        n = n+1;
    end;
end;


Ptrans = (Hinv)*(PP);
Ptrans(:,1:100)
n = sizey*sizex;  


disp('n is')
disp(n)
for i = 1:n
    Ptrans(1,i) = double(uint16(Ptrans(1,i)/Ptrans(3,i)));
    if Ptrans(1,i) == 0       %%%%%%%%% to be checked
       Ptrans(1,i) = 1;
    end;
    Ptrans(2,i) = double(uint16(Ptrans(2,i)/Ptrans(3,i)));
    if Ptrans(2,i) == 0
       Ptrans(2,i) = 1;
    end;
    Ptrans(3,i) = 1;
end;
    

             %%%%%%%%%%%%%% STEP 4 -- Computing the bounding rectangle for the workspace
Xmin = zeros(3,1);
Xmax = zeros(3,1);
Ymin = zeros(3,1);             
Ymax = zeros(3,1);

Xmin(1,1) = Ptrans(1,1);
Xmax(1,1) = Ptrans(1,1);
Ymin(2,1) = Ptrans(2,1);
Ymax(2,1) = Ptrans(2,1);

for i = 2:n
    if Ptrans(1,i) < Xmin(1,1)
        Xmin(1,1) = Ptrans(1,i);
        Xmin(2,1) = Ptrans(2,i);
        Xmin(3,1) = 1;              
    end;
    if Ptrans(1,i) > Xmax(1,1)
        Xmax(1,1) = Ptrans(1,i);
        Xmax(2,1) = Ptrans(2,i);
        Xmax(3,1) = 1;              
    end;
    if Ptrans(2,i) < Ymin(2,1)
        Ymin(1,1) = Ptrans(1,i);
        Ymin(2,1) = Ptrans(2,i);
        Ymin(3,1) = 1;              
    end;
    if Ptrans(2,i) > Ymax(2,1)
        Ymax(1,1) = Ptrans(1,i);
        Ymax(2,1) = Ptrans(2,i);
        Ymax(3,1) = 1;              
    end;
end;
        

n=1;
P=zeros(3,sizey*sizex);
for i= 1:sizey
    for j = 1:sizex
        P(1,n) = j;
        P(2,n) = i;
        P(3,n) = 1;
        n = n+1;
    end;
end;


if P(1,1) < Xmin(1,1)
    Boxleft = P(1,1);
else
    Boxleft = Xmin(1,1);
end;

if P(2,1) < Ymin(2,1)
    Boxtop = P(2,1);
else
    Boxtop = Ymin(2,1);
end;

n = sizey*sizex;

if P(1,n) > Xmax(1,1)
    Boxright = P(1,n);
else
    Boxright = Xmax(1,1);
end;

if P(2,n) > Ymax(2,1)
    Boxbottom = P(2,n);
else
    Boxbottom = Ymax(2,1);
end;

if Boxtop == 0
    Boxtop = 1;
end;
if Boxleft == 0
    Boxleft = 1;
end;

Height = double(uint16(abs(Boxtop - Boxbottom))) + 1;
Width  = double(uint16(abs(Boxleft - Boxright))) + 1;

disp('Workspace Properties')
disp('height is')
disp(Height)
disp('Width is')
disp(Width)
disp('Boxleft is')
disp(Boxleft)
disp('Boxright is')
disp(Boxright)
disp('Boxtop is')
disp(Boxtop)
disp('Boxbottom is')
disp(Boxbottom)

Workspace = zeros(Height,Width);   %%%%%%%%%%%%%   STEP 5 -- Creating Workspace
Workspace = double(Workspace);

offsetX = abs(P(1,1) - Boxleft);   %%%%%%%%%%%%%   STEP 6 -- Pasting first image in the workspace
offsetY = abs(P(2,1) - Boxtop);

disp('offsetX is')
disp(offsetX)
disp('offsetY is')
disp(offsetY)

n = sizey*sizex;

for i = 1:n
    P(1,i) = P(1,i) + offsetX;
    P(2,i) = P(2,i) + offsetY;
end;

% for i = 1:Height
%     for j = 1:Width
%         for k = 1:n
%             if P(1,k) == i & P(2,k) == j
%                 Workspace(i,j) = image1(P(1,k),P(2,k));
%                 break;
%             end;
%         end;
%     end;
% end;

for i = 1:Height
    for j = 1:Width
        if P(1,1) == j & P(2,1) == i
           break;
        end;
    end;
    if P(1,1) == j & P(2,1) == i
       break;
   end;
end;

Workspace(i:(sizey+i-1),j:(sizex+j-1)) = image1(:,:);
figure;
imshow(Workspace);


                                      %%%%%%%%%%% STEP 7 -- Pasting second image in the workspace
    
for i = 1:n   
    Ptrans(1,i) = Ptrans(1,i) + offsetX;
    Ptrans(2,i) = Ptrans(2,i) + offsetY;
end;

intensity = double(intensity);

% for i = 1:Height
%     for j = 1:Width
%         for k = 1:n
%             if Ptrans(1,k) == i & Ptrans(2,k) == j
% % %                 Rev(1,1) = Ptrans1(1,k);
% % %                 Rev(2,1) = Ptrans1(2,k);
% % %                 Rev(3,1) = 1;
% % %                 Revmap = H*Rev;
%                 if Workspace(i,j) ~= 0
% % %                    Workspace(i,j) = (Workspace(i,j) + image2(Revmap(1,1),Revmap(2,1)))/2;
%                      Workspace(i,j) = (Workspace(i,j) + intensity(1,k))/2;   
%                else
% % %                    Workspace(i,j) = image2(Revmap(1,1),Revmap(2,1));
%                      Workspace(i,j) = intensity(1,k);   
%                end;
%                break;
%             end;
%         end;
%     end;
% end;
% 
temp = zeros(sizey,sizex);
for k = 1:n
    temp(Ptrans(2,k),Ptrans(1,k)) = intensity(1,k);
end;
figure;
imshow(temp);

intensity = double(intensity);
for k = 1:n
     if Workspace(Ptrans(2,k),Ptrans(1,k)) ~= 0
         Workspace(Ptrans(2,k),Ptrans(1,k)) = (Workspace(Ptrans(2,k),Ptrans(1,k)) + intensity(1,k))/2;   
     else
        Workspace(Ptrans(2,k),Ptrans(1,k)) = intensity(1,k);   
    end;
end;

        

 imwrite(Workspace,'mosaiced.jpg');
 im = imread('mosaiced.jpg');
 figure;
 imshow(im);



