%%%%%%%% Assumptions %%%%%%%%%%%
% 1> Images are gray scale images
% 2> Images are of same size
% 3> Currently designed for 2 images with significant overlap
% 4> Finding corresponding poins in both images is done manually


image1 = imread('./pictures/mosaic_images/lab1.jpg');  
image2 = imread('./pictures/mosaic_images/lab2.jpg');      

 figure;
 imshow(image1);

 figure;
 imshow(image2);

I1 = im2double(image1);
I2 = im2double(image2);

Point1(1,1) = 1;  %% x1             %%%%%%%%%% STEP 1 -- Computing 4 corresponding points in both the images
Point1(2,1) = 1;  %% y1
Point1(1,2) = 2;  %% x2
Point1(2,2) = 2;  %% y2
Point1(1,3) = 3;  %% x3
Point1(2,3) = 3;  %% y3
Point1(1,4) = 4;  %% x4
Point1(2,4) = 4;  %% y4
Point2(1,1) = 1;  %% x1'
Point2(2,1) = 1;  %% y1'
Point2(1,2) = 2;  %% x2'
Point2(2,2) = 2;  %% y2'
Point2(1,3) = 3;  %% x3'
Point2(2,3) = 3;  %% y3'
Point2(1,4) = 4;  %% x4'
Point2(2,4) = 4;  %% y4'

x1 = Point1(1,1);            %%%%%%%%%%%%%% STEP 2 -- Estimating the homography
y1 = Point1(2,1); 
x2 = Point1(1,2); 
y2 = Point1(2,2); 
x3 = Point1(1,3); 
y3 = Point1(2,3); 
x4 = Point1(1,4);  
y4 = Point1(2,4);
xx1 = Point2(1,1);   
yy1 = Point2(2,1); 
xx2 = Point2(1,2); 
yy2 = Point2(2,2);
xx3 = Point2(1,3);
yy3 = Point2(2,3);
xx4 = Point2(1,4);
yy4 = Point2(2,4);

A = zeros(8,8);
B = zeros(8,1);
X = zeros(8,1);
H = zeros(3,3);

A = [x1 y1 1 0 0 0 -(x1*xx1) -(y1*xx1) ; 0 0 0 x1 y1 1 -(x1*yy1) -(y1*yy1); x2 y2 1 0 0 0 -(x2*xx2) -(y2*xx2) ; 0 0 0 x2 y2 1 -(x2*yy2) -(y2*yy2); x3 y3 1 0 0 0 -(x3*xx3) -(y3*xx3) ; 0 0 0 x3 y3 1 -(x3*yy3) -(y3*yy3); x4 y4 1 0 0 0 -(x4*xx4) -(y4*xx4) ; 0 0 0 x4 y4 1 -(x4*yy4) -(y4*yy4)];
B = [xx1; yy1; xx2; yy2; xx3; yy3; xx4; yy4];

X = A\B;


H = [X(1,1) X(2,1) X(3,1); X(4,1) X(5,1) X(6,1); X(7,1) X(8,1) 1];

Hinv = zros(3,3);                    %%%%%%%%%%%%%% STEP 3 -- Applying H-inverse to the right image
Hinv = inv(H);

[sizey sizex] = size(image2);

m=1;
n=1;
PP=0;
for i= 1:sizey
    for j = 1:sizex
        PP(m,n) = i;
        m = m+1;
        PP(m,n) = j;
        m = m+1;
        PP(m,n) = 1;
        n = n+1;
        m=1;
    end;
end;

n=1;
for i = 1:sizey
    for j = 1:sizex
        intensity(1,n) = image2(i,j);
        n = n+1;
    end;
end;


Ptrans = (Hinv)*(PP);
n = sizey*sizex;  



for i = 1:n
    Ptrans(1,i) = Ptrans(1,i)/Ptrans(3,i);
    Ptrans(2,i) = Ptrans(2,i)/Ptrans(3,i);
    Ptrans(3,i) = 1;
end;


             %%%%%%%%%%%%%% STEP 4 -- Computing the bounding rectangle for the workspace

Xmin(1,1) = Ptrans(1,1);
Xmax(1,1) = Ptrans(1,1);
Ymin(2,1) = Ptrans(2,1);
Ymax(2,1) = Ptrans(2,1);

for i = 2:n
    if Ptrans(1,i) < Xmin(1,1)
        Xmin(1,1) = Ptrans(1,i);
        Xmin(2,1) = Ptrans(2,i);
        Xmin(3,1) = 1;              
    end;
    if Ptrans(1,i) > Xmax(1,1)
        Xmax(1,1) = Ptrans(1,i);
        Xmax(2,1) = Ptrans(2,i);
        Xmax(3,1) = 1;              
    end;
    if Ptrans(2,i) < Ymin(2,1)
        Ymin(1,1) = Ptrans(1,i);
        Ymin(2,1) = Ptrans(2,i);
        Ymin(3,1) = 1;              
    end;
    if Ptrans(1,i) > Ymax(2,1)
        Ymax(1,1) = Ptrans(1,i);
        Ymax(2,1) = Ptrans(2,i);
        Ymax(2,1) = 1;              
    end;
end;
        

m=1;
n=1;
P=0;
for i= 1:sizey
    for j = 1:sizex
        P(m,n) = i;
        m = m+1;
        P(m,n) = j;
        m = m+1;
        P(m,n) = 1;
        n = n+1;
        m=1;
    end;
end;


if P(1,1) < Xmin(1,1)
    Boxleft = P(1,1);
else
    Boxleft = Xmin(1,1);
end;

if P(2,1) < Ymin(2,1)
    Boxtop = P(2,1);
else
    Boxtop = Ymin(2,1);
end;

n = sizey*sizex;

if P(1,n) > Xmax(1,1)
    Boxright = P(1,n);
else
    Boxright = Xmax(1,1);
end;

if P(2,n) > Ymax(2,1)
    Boxbottom = P(2,n);
else
    Boxbottom = Ymin(2,1);
end;

height = abs(Boxtop - Boxbottom);
Width  = abs(Boxleft - Boxright);

Workspace = zeros(height,width);   %%%%%%%%%%%%%   STEP 5 -- Creating Workspace

offsetX = abs(P(1,1) - Boxleft);   %%%%%%%%%%%%%   STEP 6 -- Pasting first image in the workspace
offsetY = abs(P(2,1) - Boxtop);

n = sizey*sizex;

for i = 1:n
    P(1,i) = P(1,i) + offsetX;
    P(2,i) = P(2,i) + offsetY;
end;

for i = 1:height
    for j = 1:width
        for k = 1:n
            if P(1,k) == i & P(2,k) == j
                Workspace(i,j) = image1(P(1,k),P(2,k));
                break;
            end;
        end;
    end;
end;


                                      %%%%%%%%%%% STEP 7 -- Pasting second image in the workspace
    
for i = 1:n   
    Ptrans(1,i) = Ptrans(1,i) + offsetX;
    Ptrans(2,i) = Ptrans(2,i) + offsetY;
end;

for i = 1:height
    for j = 1:width
        for k = 1:n
            if Ptrans(1,k) == i & Ptrans(2,k) == j
%                 Rev(1,1) = Ptrans1(1,k);
%                 Rev(2,1) = Ptrans1(2,k);
%                 Rev(3,1) = 1;
%                 Revmap = H*Rev;
                if Workspace(i,j) ~= 0
%                    Workspace(i,j) = (Workspace(i,j) + image2(Revmap(1,1),Revmap(2,1)))/2;
                     Workspace(i,j) = (Workspace(i,j) + intensity(1,k))/2;   
               else
%                    Workspace(i,j) = image2(Revmap(1,1),Revmap(2,1));
                     Workspace(i,j) = intensity(1,k);   
               end;
               break;
            end;
        end;
    end;
end;


 imwrite(Workspace,'mosaiced.jpg');
 im = imread('mosaiced.jpg');
 figure;
 imshow(im);



